<template>
  <div class="sa-toggle" :class="size" data-testid="toggle">
    <label :id="uniqueId" class="label" data-testid="label">{{ label }}</label>
    <fieldset class="fieldset" role="radiogroup" :aria-labelledby="uniqueId">
      <button
        v-for="option in optionsList"
        :key="option.value"
        :data-testid="option.value"
        :class="optionClasses(option)"
        role="radio"
        :aria-checked="option.value === activeValue"
        @click="setOption(option)"
      >
        <span class="text" :data-testid="option.label">{{ option.label }}</span>
      </button>
    </fieldset>
  </div>
</template>

<script>
export default {
  name: 'SaToggle',
  props: {
    label: {
      type: String,
      required: true
    },
    initialValue: {
      type: String,
      default: null
    },
    options: {
      type: Array,
      default: () => []
    },
    size: {
      type: String,
      default: 'regular'
    }
  },
  data(props) {
    const { initialValue, options } = props
    const optionsList = options.map((option) => {
      if (typeof option === 'object') {
        return option
      }
      return {
        value: option,
        label: option
      }
    })

    let activeValue = initialValue
    if (
      (activeValue === null || typeof activeValue === 'undefined') &&
      optionsList.length > 0
    ) {
      activeValue = optionsList[0].value
    }

    return {
      optionsList,
      activeValue,
      uniqueId: this.makeUniqueId()
    }
  },
  methods: {
    optionClasses(option) {
      const classes = ['option']
      if (option.value === this.activeValue) {
        classes.push('active')
      }
      return classes
    },
    setOption(option) {
      this.activeValue = option.value
      this.$emit('change', option)
    }
  }
}
</script>

<style lang="scss" scoped>
.fieldset {
  display: inline-block;
  white-space: nowrap;
}
.sa-toggle {
  .option {
    border-bottom: 2px solid transparent;
    transition: $transition;
    &.active,
    &.active:hover,
    &.active:focus {
      border-bottom-color: color(primary);
    }
    &:hover,
    &:focus {
      border-bottom-color: color(primary-light);
    }
  }
  &.small .option {
    padding-bottom: spacing(0);
    font-size: font-size(0);
    + .option {
      margin-left: spacing(1);
    }
  }
  &.regular .option {
    padding-bottom: spacing(1);
    font-size: font-size(1);
    + .option {
      margin-left: spacing(2);
    }
  }
  &.large .option {
    padding-bottom: spacing(1);
    font-size: font-size(2);
    + .option {
      margin-left: spacing(2);
    }
  }
}
</style>
